#!/bin/bash

if [[ (-n "$VOC_STREAMING_AUTH") && (-n "$YOUTUBE_STREAMING_AUTH") ]]; then
  STREAMING_FORMAT="tee"
  STREAMING_TARGET="[f=flv]rtmp://x.rtmp.youtube.com/live2/${YOUTUBE_STREAMING_AUTH}|[f=flv]rtmp://ingest.c3voc.de/stream/${EVENT}?auth=${VOC_STREAMING_AUTH}"
elif [[ -n "$VOC_STREAMING_AUTH" ]]; then
  STREAMING_FORMAT="flv"
  STREAMING_TARGET="rtmp://ingest.c3voc.de/stream/${EVENT}?auth=${VOC_STREAMING_AUTH}"
elif [[ -n "$YOUTUBE_STREAMING_AUTH" ]]; then
  STREAMING_FORMAT="flv"
  STREAMING_TARGET="rtmp://a.rtmp.youtube.com/live2/${YOUTUBE_STREAMING_AUTH}"
else
    echo "[ERROR] failed to start stream, credentials missing!"
    exit 1
fi

ffmpeg -y -nostdin -hide_banner -re \
    -init_hw_device vaapi=vaapi0:/dev/dri/renderD128 \
    -hwaccel vaapi \
    -hwaccel_output_format vaapi \
    -thread_queue_size 512 -i tcp://localhost:15000?timeout=3000000 \
    -filter_hw_device vaapi0 \
    -filter_complex "[0:v]hqdn3d,format=nv12,hwupload[hd];" \
    -c:v h264_vaapi \
    -flags +cgop -aspect 16:9 \
    -r:v:0 30 -g:v:0 90 -crf:v:0 21 -maxrate:v:0 6M -bufsize:v:0 24M \
    -c:a aac -b:a 192k -ar 48000 \
    -map "[hd]" \
    -metadata:s:v:0 title="HD" \
    -map "0:a:0" -metadata:s:a:0 title="native" \
    -f "${STREAMING_FORMAT}" "${STREAMING_TARGET}"
